﻿using System;
using System.Globalization;
using ETHZ.C0284H.Calculator.Instruct.Visitor;
using ETHZ.C0284H.Calculator.Utils;

namespace ETHZ.C0284H.Calculator.Instruct.Commands
{
    public sealed class LanguageInstruct : ICalculatorInstruct
    {

        public LanguageInstruct(SupportedLanguage language, CultureInfo culture)
        {
            if (culture == null)
            {
                throw new ArgumentNullException("culture");
            }

            InstructCode = language.ToString().ToLower();
            InstructText = Enums.GetEnumDescription(language).ToLower();
            Language = language;
            Culture = culture;
        }

        public string InstructText { get; private set; }
        public string InstructCode { get; private set; }
        public SupportedLanguage Language { get; private set; }
        public CultureInfo Culture { get; private set; }

        public void Accept(ICalculatorInstructVisitor visitor)
        {
            if (visitor != null)
            {
                visitor.VisitCommand(this);    
            }
        }
    }
}