﻿using ETHZ.C0284H.Calculator.Instruct.Visitor;

namespace ETHZ.C0284H.Calculator.Instruct
{
    /// <summary>
    /// Interface for text calculator instructs.
    /// </summary>
    public interface ICalculatorInstruct
    {
        /// <summary>
        /// Gets the user-friendly represantation of instruct.
        /// </summary>
        string InstructText { get; }

        /// <summary>
        /// Gets the system code of instruct.
        /// </summary>
        string InstructCode { get; }

        /// <summary>
        /// Accepts an instruct visitor.
        /// </summary>
        /// <param name="visitor">A visitor.</param>
        void Accept(ICalculatorInstructVisitor visitor);
    }
}
